/* code to allow nos to talk directly to bpqcode
 *
 * by paul h launspach n5faz
 * (c) 1993 FazCom
 * 4-13-93
 */
/* $Id: bpqmail.c 1.5 1994/03/23 06:38:13 fz-phl Exp $ */
/* $Log: bpqmail.c $
 * Revision 1.5  1994/03/23  06:38:13  fz-phl
 * initial revision
 *
 */

#include <ctype.h>
#include "global.h"
#include "proc.h"
#include "socket.h"
#include "usock.h"
#include "session.h"
#include "commands.h"
#include "mailbox.h"
#include "bpq.h"

int
bpqstart(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct bpq_servers *serv;
    struct bpq_serv *bsp;
    struct usock *up;
    int s,type;
    FILE *network;
    struct sockaddr_bq local;
    char tmp[40];
    char *ag[1];

    if(!Bpqinfo.vec){
        printf("Bpq must be initilized with:\nattach bpq init <vec> <stream>\n");
        return -1;
    }
    for(serv=Bpqserv;serv->name != NULLCHAR;serv++)
        if(strncmp(argv[1],serv->name,strlen(argv[1])) == 0)
            break;

    if(serv->name == NULLCHAR){
        printf("Usage: start bpq ");
        serv = Bpqserv;
        printf("%s",(serv++)->name);
        for(;serv->name != NULLCHAR;serv++)
            printf("|%s",serv->name);
        printf(" <appl> [users]\n");
        return -1;
    }

    psignal(Curproc,1);
    sprintf(tmp,"BPQ %s Listener",serv->name);
    tmp[16] = '\0';
    chname(Curproc,tmp);
    bsp = (struct bpq_serv *)callocw(1,sizeof(struct bpq_serv));
    bsp->serv = serv;
    bsp->next = Bpqinfo.serv;
    Bpqinfo.serv = bsp;
    bsp->s = socket(AF_BPQ,SOCK_STREAM,0);
    local.bpq_family = AF_BPQ;
    memcpy(local.bpq_addr,serv->name,AXBUF);
    ag[1] = serv->name;
    bsp->appl = atoi(argv[2]);
    local.bpq_appl = 1 << (bsp->appl-1);
    local.bpq_flag = serv->flag;
    if(argc > 3)
         bsp->users = atoi(argv[3]);
    else bsp->users = 1;
    Bpqinfo.maxstream += bsp->users;
    bind(bsp->s,(char *)&local,sizeof(local));
    if(listen(bsp->s,1) == -1){
        close_s(bsp->s);
        bsp->s = -1;
        Bpqinfo.serv = bsp->next;
        Bpqinfo.maxstream -= bsp->users;
        free((char *)bsp);
        return -1;
    }

    up = itop(bsp->s);
    up->cb.bpq->serv = bsp;

    for(;;){
        if((s = accept(bsp->s,NULLCHAR,NULLINT)) == -1)
            break;

        if(++bsp->curr > bsp->users){
            network = fdopen(s,"r+t");
            fprintf(network,"All %s ports are in use.\n",serv->name);
            fflush(network);
            shutdown(s,0);
            close_s(s);
        } else {
            type = BPQSESSION;
            up = itop(s);
            up->cb.bpq->sconn = bsp->curr;
            if(serv->file)
                network = fdopen(s,"r+t");
            else network = NULL;
            newproc(serv->name,serv->stack,serv->task,s,
              (void *)&type,(void *)network,0);
        }
    }

    /* call stop to clean us up ... */
    return bpq0(2,ag,NULL);

}

int
bpq0(argc,argv,p)
int argc;
char *argv[];
void *p;
{
    struct bpq_serv *bsp, *bsp1 = NULLBPQS;

    for(bsp = Bpqinfo.serv;bsp != NULLBPQS;bsp1 = bsp, bsp = bsp->next)
        if(strncmp(argv[1],bsp->serv->name,strlen(argv[1])) == 0)
            break;

    if(bsp == NULLBPQS)   /* not found */
        return -1;

    close_s(bsp->s);

    /* unlink us ... */
    if(bsp1 == NULLBPQS)
        Bpqinfo.serv = bsp->next;
    else
        bsp1->next = bsp->next;

    Bpqinfo.maxstream -= bsp->users;
    free(bsp);

    return 0;
}
void
bpqfinger(s,t,p)
int s;
void *t;
void p;
{
    FILE *network;
    int c;
    struct mbuf *bp;
    char buf[72];
    char *tmp;
    int cnt = 1;
    struct usock *up;

    tmp=buf;
    recv_mbuf(s,&bp,0,NULLCHAR,NULLINT);

    /* all this is nessary because the users command returned by */
    /* bpq is 72 bytes space padded */

    /* skip the first word */
    while((c=PULLCHAR(&bp)) != -1 && strchr(Whitespace,c) == NULLCHAR);

    /* skip any space */
    while(c != -1 && strchr(Whitespace,c) != NULLCHAR)
        c=PULLCHAR(&bp);

    /* copy second word to a new buf */
    while(c != -1 && strchr(Whitespace,c) == NULLCHAR && sizeof(buf)-cnt > 1){
        *tmp++ = c;
        cnt++;
        c = PULLCHAR(&bp);
    }
    *tmp = '\r';

    free_p(bp);
    bp = qdata(buf,cnt);
    up = itop(s);
    free_q(&up->cb.bpq->rxq);
    append(&up->cb.bpq->rxq,bp);    /* put our new line on the rxq */
    psignal(up,0);                  /* tell recv_mbuf that it is there  */

    fingerd(s,NULL,NULL);
}

