/* code to allow nos to talk directly to bpqcode
 *
 * by paul h launspach n5faz
 * (c) 1993 FazCom
 * 4-13-93
 */
/* $Id: bpqsubr.c 1.5 1994/03/23 06:38:13 fz-phl Exp $ */
/* $Log: bpqsubr.c $
 * Revision 1.5  1994/03/23  06:38:13  fz-phl
 * initial revision
 *
 */

#include "global.h"
#include "mbuf.h"
#include "ax25.h"
#include "usock.h"
#include "bpq.h"

/* bpq recieve process. */
void
bpqrxp(n1,n2,n3)
int n1;
void *n2, *n3;
{
    register int i;
    int new;
    uint16 ns;
    struct bpq_cb *cb, *cb2;
    struct mbuf *bp = NULLBUF;
    struct usock *up;

    /* set it up */



    for(;;){
        for(cb = Bpqinfo.cb; cb != NULLBPQ; cb = cb->next){
            /* check for state changes  */
            ns = bpq_int(BPQ_STATE,cb->stream,0,NULLCHAR);
            if(ns & BPQ_ST_CHG){
                if(ns & BPQ_ST_CON){
                    /* get call of who connected to us  */
                    bpq_int(BPQ_USERCALL,cb->stream,0,cb->remote);
                    /* see if we are a server and */
                    if(cb->state & BPQ_ST_LIS ){
                        /* try to get new cb */
                        /* new cb becomes the listener and */
                        /* orignal becomes the clone       */
                        if((cb2 = cr_bpq()) == NULLBPQ){
                            /* refuse it */
                            bpq_int(BPQ_ACKSTATE,cb->stream,0,NULLCHAR);
                            bpq_int(BPQ_CONNECT,cb->stream,BPQ_DISC,NULLCHAR);
                            ns = cb->state;
                        } else {
                            cb2->state = BPQ_ST_LIS;
                            cb2->mode = cb->mode;
                            cb2->appl = cb->appl;
                            cb2->applflag = cb->applflag;
                            cb2->r_upcall = cb->r_upcall;
                            cb2->t_upcall = cb->t_upcall;
                            cb2->s_upcall = cb->s_upcall;
                            cb2->serv = cb->serv;
                            cb2->user = cb->user;
                            new = cb2->conn;
                            cb2->conn = cb->conn;
                            cb->conn = new;
                            up = itop(cb2->user);
                            if(up != NULLUSOCK)
                                up->cb.bpq = cb2;
                            memcpy(cb2->local,cb->local,AXBUF);
                            /* allow new connects on new cb */
                            /* and stop new connects on old cb */
                            bpq_int(BPQ_SET,cb2->stream,
                             cb2->appl <<8 | cb2->applflag,NULLCHAR);
                            bpq_int(BPQ_SET,cb->stream,0,NULLCHAR);
                        }   /* if(cb2=nullbpq) */
                    }   /* if(bpq_st_lis && server) */
                }   /* if(bpq_st_con) */
                ns &= ~BPQ_ST_CHG;
                if(cb->state != ns){
                    if(cb->s_upcall != NULLVFP)
                        (*cb->s_upcall)(cb,cb->state,ns);
                    cb->state = ns;
                }   /* if(state != ns) */
                if(!cb->state)
                    del_bpq(cb);
            }   /* if(ns & bpq_st_chg) */

            /* have to ack the state change call  */
            bpq_int(BPQ_ACKSTATE,cb->stream,0,NULLCHAR);

            /* check for any recieved data */
            if(ns & BPQ_ST_CON){
                /* try to send any data on the txq */
                bpq_out(cb);
                /* get a buffer to put any recieved data into */
                if(bp == NULLBUF && (bp = ambufw(BPQSIZE)) == NULLBUF)
                        break;
                /* put the data on the rxqueue  */
                /* and tell sombody its there */
                new =0;
                while(bp != NULLBUF &&
                  (bp->cnt = bpq_int(BPQ_RECV,cb->stream,0,bp->data)) > 0){
                    append(&cb->rxq,bp);
                    bp = alloc_mbuf(BPQSIZE);
                    new++;
                }   /* if(bp->cnt =) */
                cb->recv += new;
                Bpqinfo.recv += new;
                if(new && cb->r_upcall != NULLVFP)
                        (*cb->r_upcall)(cb,len_p(cb->rxq));
            }   /* if(bpq_st_con)  */
        }   /* for(cb=;cb !=nullbpq;cb=next) */

        /* let everything else run  */
        alarm(500L);
        pwait(Bpqinfo.rxproc);
        alarm(0L);
    }   /* for(;;)  */
}       

/* stop bpq recieve process */
void
bpqstop(void)
{
    struct bpq_cb *cb;

    /* kill any connections */
    for(cb = Bpqinfo.cb;cb != NULLBPQ; cb = cb->next)
        disc_bpq(cb,1);

    /* signal the rx proc and let it clean up */
    psignal(Bpqinfo.rxproc,1);
    pwait(NULL);

}

/* find first free stream and create bpq_cb */
struct bpq_cb *
cr_bpq()
{
    int i;
    struct bpq_cb *cb,*cb1 = NULLBPQ;

    i = Bpqinfo.monstream;
    for(cb=Bpqinfo.cb;cb != NULLBPQ && i == cb->stream;
      i++, cb1 = cb, cb = cb->next)
            ;

    if( i > Bpqinfo.maxstream || i > BPQMAXSTREAM)
        return NULLBPQ;

    cb = (struct bpq_cb *)callocw(1,sizeof(struct bpq_cb));

    if(cb1 == NULLBPQ){
        cb->next = Bpqinfo.cb;
        Bpqinfo.cb = cb;
    } else {
        cb->next = cb1->next;
        cb1->next = cb;
    }
    cb->stream = i;
    cb->conn = ++Bpqinfo.nextconn;
    cb->rxq = NULLBUF;
    cb->txq = NULLBUF;

    if(++Bpqinfo.curr > Bpqinfo.maxconn)
        Bpqinfo.maxconn = Bpqinfo.curr;

    return cb;
}

/* free bpq_cb */
void
del_bpq(con)
struct bpq_cb *con;
{
    struct bpq_cb *cb, *cb1 = NULLBPQ;
    int maxc = 0;

    if(con == NULLBPQ)
        return;

    for(cb = Bpqinfo.cb; cb != NULLBPQ; cb1 = cb, cb = cb->next)
        if(cb == con)
            break;

    if(cb == NULLBPQ)       /* not found  */
        return;

    /* remove from list  */
    if(cb1 != NULLBPQ)
        cb1->next = cb->next;
    else
        Bpqinfo.cb = cb->next;

    if(cb->serv != NULLBPQS)
        cb->serv->curr--;

    for(cb1 = Bpqinfo.cb; cb1 != NULLBPQ; cb1 = cb1->next){
        maxc = max(maxc,cb1->conn);
        if(cb->serv != NULLBPQS && cb1->serv != NULLBPQS
          && cb1->serv == cb->serv && cb1->sconn > cb->sconn)
            cb1->sconn--;
    }
    Bpqinfo.nextconn = maxc;
    Bpqinfo.curr--;

    /* free resources */
    free_q(&cb->txq);
    free_q(&cb->rxq);
    free((char *)cb);

    return;
}

